/****************************************************
  Projekt: TMCM-ARM (TMCL fr ARM-Module)

  Modul:   TMC262-ARM.c
           Zugriffsfunktionen fr den TMC262

  Datum:   12.11.2009 OK
*****************************************************/

#ifndef __EVAL429_TMC262_H
#define __EVAL429_TMC262_H

#define TMC262_RB_MSTEP        0
#define TMC262_RB_STALL_GUARD  1
#define TMC262_RB_SMART_ENERGY 2
#define TMC262_RB_ENCODER      3


//Funktionen fr den Zugriff auf den TMC262
void InitMotorDrivers(void);
void Set262StepDirMStepRes(UCHAR Which262, UCHAR MicrostepResolution);
void Set262StepDirInterpolation(UCHAR Which262, UCHAR Interpolation);
void Set262StepDirDoubleEdge(UCHAR Which262, UCHAR DoubleEdge);
UCHAR Get262StepDirMStepRes(UCHAR Which262);
UCHAR Get262StepDirInterpolation(UCHAR Which262);
UCHAR Get262StepDirDoubleEdge(UCHAR Which262);

void Set262ChopperBlankTime(UCHAR Which262, UCHAR BlankTime);
void Set262ChopperMode(UCHAR Which262, UCHAR Mode);
void Set262ChopperRandomTOff(UCHAR Which262, UCHAR RandomTOff);
void Set262ChopperHysteresisDecay(UCHAR Which262, UCHAR HysteresisDecay);
void Set262ChopperHysteresisEnd(UCHAR Which262, UCHAR HysteresisEnd);
void Set262ChopperHysteresisStart(UCHAR Which262, UCHAR HysteresisStart);
void Set262ChopperTOff(UCHAR Which262, UCHAR TOff);
UCHAR Get262ChopperBlankTime(UCHAR Which262);
UCHAR Get262ChopperMode(UCHAR Which262);
UCHAR Get262ChopperRandomTOff(UCHAR Which262);
UCHAR Get262ChopperHysteresisDecay(UCHAR Which262);
UCHAR Get262ChopperHysteresisEnd(UCHAR Which262);
UCHAR Get262ChopperHysteresisStart(UCHAR Which262);
UCHAR Get262ChopperTOff(UCHAR Which262);

void Set262SmartEnergyIMin(UCHAR Which262, UCHAR SmartIMin);
void Set262SmartEnergyDownStep(UCHAR Which262, UCHAR SmartDownStep);
void Set262SmartEnergyStallLevelMax(UCHAR Which262, UCHAR StallLevelMax);
void Set262SmartEnergyUpStep(UCHAR Which262, UCHAR SmartUpStep);
void Set262SmartEnergyStallLevelMin(UCHAR Which262, UCHAR StallLevelMin);
UCHAR Get262SmartEnergyIMin(UCHAR Which262);
UCHAR Get262SmartEnergyDownStep(UCHAR Which262);
UCHAR Get262SmartEnergyStallLevelMax(UCHAR Which262);
UCHAR Get262SmartEnergyUpStep(UCHAR Which262);
UCHAR Get262SmartEnergyStallLevelMin(UCHAR Which262);

void Set262StallGuardFilter(UCHAR Which262, UCHAR Enable);
void Set262StallGuardThreshold(UCHAR Which262, signed char Threshold);
void Set262StallGuardCurrentScale(UCHAR Which262, UCHAR CurrentScale);
UCHAR Get262StallGuardFilter(UCHAR Which262);
signed char Get262StallGuardThreshold(UCHAR Which262);
UCHAR Get262StallGuardCurrentScale(UCHAR Which262);

void Set262DriverSlopeHighSide(UCHAR Which262, UCHAR SlopeHighSide);
void Set262DriverSlopeLowSide(UCHAR Which262, UCHAR SlopeLowSide);
void Set262DriverDisableProtection(UCHAR Which262, UCHAR DisableProtection);
void Set262DriverProtectionTimer(UCHAR Which262, UCHAR ProtectionTimer);
void Set262DriverStepDirectionOff(UCHAR Which262, UCHAR SDOff);
void Set262DriverVSenseScale(UCHAR Which262, UCHAR Scale);
void Set262DriverReadSelect(UCHAR Which262, UCHAR ReadSelect);
void Set262DriverTestMode(UCHAR Which262, UCHAR TestMode);
UCHAR Get262DriverSlopeHighSide(UCHAR Which262);
UCHAR Get262DriverSlopeLowSide(UCHAR Which262);
UCHAR Get262DriverDisableProtection(UCHAR Which262);
UCHAR Get262DriverProtectionTimer(UCHAR Which262);
UCHAR Get262DriverStepDirectionOff(UCHAR Which262);
UCHAR Get262DriverVSenseScale(UCHAR Which262);
UCHAR Get262DriverReadSelect(UCHAR Which262);
UCHAR Get262DriverTestMode(UCHAR Which262);

void Disable262(UCHAR Which262);
void Enable262(UCHAR Which262);

void Read262State(UCHAR Which262, UCHAR *Phases, UCHAR *MStep, UINT *StallGuard, UCHAR *SmartEnergy, UCHAR *Flags);
void GetSPIData(UCHAR Index, int *Data);
#endif
